                .processor 6502

                .org $c000

vblankcount	= $00
savea           = $01
savex           = $02
savey           = $03
srclo           = $04
srchi           = $05

start:          lda #$00                        ;No NMI yet
                sta $2000
                sta $2001
                cld
                ldx #$ff
                txs
		jsr clearmemory
                jsr mt_stop			;Init audio
		jsr initppu                     ;NMI's on
                jsr initmapper
                jsr waitvblank
                jsr loadchars
                jsr loadpalette
                jsr setnametable
                lda #$08                        ;Display on
                sta $2001
                lda #$00
                jsr mt_init 			;Start playing song 0
mainloop:       jsr waitvblank
         	jmp mainloop

waitvblank:	lda vblankcount
wv_loop:	cmp vblankcount
		beq wv_loop
                lda $2002                       ;Reset flip-flop
		rts

clearmemory:	ldx #$00
		txa
cm_loop:	sta $00,x
		sta $200,x
		sta $300,x
		sta $400,x
		sta $500,x
		sta $600,x
		sta $700,x
		inx
		bne cm_loop
		rts

initppu:	lda #$80		;Vblank NMI on
		sta $2000
		lda #$00 		;No screen display
		sta $2001
		rts

initmapper:     lda #$1e
write8000:      pha                     ;Write to MMC 1 mapper
                lda #$80                ;First reset
                sta $8000               ;Then 5 bits of data
                pla
                sta $8000
                lsr
                sta $8000
                lsr
                sta $8000
                lsr
                sta $8000
                lsr
                sta $8000
                rts

loadpalette:    lda #$3f
                sta $2006
                lda #$00
                sta $2006
                ldx #$00
loadpalette2:   lda palette,x
                sta $2007
                inx
                cpx #$10
                bne loadpalette2
                rts

loadchars:      lda #$00
                sta $2006
                sta $2006
                lda #<chardata
                sta srclo
                lda #>chardata
                sta srchi
                ldy #$00
                ldx #$10
loadchars2:     lda (srclo),y
                sta $2007
                iny
                bne loadchars2
                inc srchi
                dex
                bne loadchars2
                rts

setnametable:   lda #$20        ;Write to nametable0
                sta $2006
                lda #$00
                sta $2006
                ldx #$04        ;4 pages
                ldy #$00
                lda #$20
sntloop1:       sta $2007
                iny
                bne sntloop1
                dex
                bne sntloop1
                lda #$23        ;Then write to attrib.table0
                sta $2006
                lda #$c0
                sta $2006
                ldy #$40
                lda #$00
sntloop2:       sta $2007
                dey
                bne sntloop2
                lda #>$2141     ;Then write the text
                sta $2006
                lda #<$2141
                sta $2006
                ldy #$00
sntloop3:       lda text1,y
                beq sntloop3end
                and #$3f
                sta $2007
                iny
                jmp sntloop3
sntloop3end:    lda #>$2181
                sta $2006
                lda #<$2181
                sta $2006
                ldy #$00
sntloop4:       lda text2,y
                beq sntloop4end
                and #$3f
                sta $2007
                iny
                jmp sntloop4
sntloop4end:    lda #$00
                sta $2005               ;Reset scrolling
                sta $2005
                rts

text1:          dc.b " ** GOLDRUNNER MUSIC DEMO **",0
text2:          dc.b "  WRITTEN BY CADAVER 4/2000 ",0








nmi:            sta savea
                stx savex
                sty savey
                inc vblankcount
                jsr mt_music
                lda savea
                ldx savex
                ldy savey
irq:		rti

	;Music routine

C0              = 0
CS0             = 1
D0              = 2
DS0             = 3
E0              = 4
F0              = 5
FS0             = 6
G0              = 7
GS0             = 8
A0              = 9
AS0             = 10
H0              = 11
C1              = 12
CS1             = 13
D1              = 14
DS1             = 15
E1              = 16
F1              = 17
FS1             = 18
G1              = 19
GS1             = 20
A1              = 21
AS1             = 22
H1              = 23
C2              = 24
CS2             = 25
D2              = 26
DS2             = 27
E2              = 28
F2              = 29
FS2             = 30
G2              = 31
GS2             = 32
A2              = 33
AS2             = 34
H2              = 35
C3              = 36
CS3             = 37
D3              = 38
DS3             = 39
E3              = 40
F3              = 41
FS3             = 42
G3              = 43
GS3             = 44
A3              = 45
AS3             = 46
H3              = 47
C4              = 48
CS4             = 49
D4              = 50
DS4             = 51
E4              = 52
F4              = 53
FS4             = 54
G4              = 55
GS4             = 56
A4              = 57
AS4             = 58
H4              = 59
C5              = 60
CS5             = 61
D5              = 62
DS5             = 63
E5              = 64
F5              = 65
FS5             = 66
G5              = 67
GS5             = 68
A5              = 69
AS5             = 70
H5              = 71

WAVE_87		= $00
WAVE_75		= $40
WAVE_50		= $80
WAVE_25		= $c0

PHASE_ATK	= 0
PHASE_DEC	= 1
PHASE_SUS	= 2
PHASE_REL	= 3

CMD_NOTE	= 0
CMD_REST	= 128
CMD_CONT	= 129
CMD_SND		= 130
CMD_ARP		= 131
CMD_SLIDE	= 132
CMD_ENDPATT	= 255

CMD_TRANS	= 192
CMD_ENDSONG	= 254
CMD_JUMPSONG	= 255

CMD_JUMPARP	= 255
CMD_JUMPVOL	= 255

SND_WAVEFORM 	= 0
SND_VIBDELAY 	= 1
SND_VIBSPEED 	= 2
SND_VIBDEPTH 	= 3
SND_SUSTTIME 	= 4
SND_RELSPEED 	= 5
SND_VOLINDEX 	= 6
SND_ARPINDEX 	= 7

	;These are variables needed by player. Locations can be chosen
	;freely.

mt_temp		= $f9
mt_ptbllo	= $fa
mt_ptblhi	= $fb
mt_sptrlo	= $fc
mt_sptrhi	= $fd
mt_pptrlo	= $fe
mt_pptrhi	= $ff

mt_playing	= $7af
mt_chnfreqlo	= $7b0
mt_chnfreqhi	= $7b4
mt_chnlasthi    = $7b8
mt_chnvolume	= $7bc
mt_chnwaveform	= $7c0
mt_chnsptrlo	= $7c4
mt_chnsptrhi 	= $7c8
mt_chnptindex	= $7cc
mt_chnnote	= $7d0
mt_chnsndnum	= $7d4
mt_chnarpreload = $7d8
mt_chnarpindex	= $7dc
mt_chnvolindex	= $7e0
mt_chncounter	= $7e4
mt_chnsusttime  = $7e8
mt_chnvibadd	= $7ec
mt_chnvibdelay	= $7f0
mt_chnvibcount	= $7f4
mt_chntrans	= $7f8
mt_chnslide     = $7fc

	;Routine to start music playback.
	;A = song number

mt_init:	pha			;Save song number
		jsr mt_stop		;Stop sound first
		pla
                asl
                sta mt_temp
		asl			;Multiply with 10 to get song-table
		asl			;index
                adc mt_temp
                tay
                ldx #$00
mt_init1:	lda mt_songtbl,y  	;Load song pointer
		sta mt_chnsptrlo,x
		lda mt_songtbl+1,y
		sta mt_chnsptrhi,x
		lda #$00
		sta mt_chnptindex,x	;Reset pattern index
                sta mt_chnarpindex,x	;Reset arpeggio & volume table index
                sta mt_chnvolindex,x
                sta mt_chnvibdelay,x    ;Reset vibrato delay
		sta mt_chntrans,x	;Reset transpose
		lda #$02
		sta mt_chncounter,x	;Reset note duration counter
		iny
		iny
		inx
		cpx #$04		;Loop for all 4 channels
		bcc mt_init1
		lda mt_songtbl,y 	;Pointer to pattern table
		sta mt_ptbllo
		lda mt_songtbl+1,y
		sta mt_ptblhi
		stx mt_playing		;Flag: start playing
		rts

	;Routine to stop music playback

mt_stop:	ldx #$03
		lda #$00      		;Set playing flag: not playing
		sta mt_playing
mt_stoploop:    lda #$00
		sta mt_chnvolume,x	;Set volume to zero
                sta mt_chnwaveform,x	;and reset waveform
                lda #$ff          	;Force reload of high-frequency
                sta mt_chnlasthi,x
                dex
                bpl mt_stoploop
                jmp mt_loadchannels

	;Routine that plays the music (to be called on each vblank)

mt_music:	lda mt_playing		;Check playflag
		bne mt_playok
		rts			;Not playing
mt_playok:	ldx #$00
mt_chnloop:     dec mt_chncounter,x	;Decrement note duration
		beq mt_newnote
		lda mt_chncounter,x	;If 1 tick remains, check end of
		cmp #$01		;pattern beforehand
                bne mt_nocheck
		jsr mt_getpattern
		jsr mt_checkpattend
mt_nocheck:	jmp mt_effects
mt_newnote:     jsr mt_getpattern

mt_getnote:	lda (mt_pptrlo),y
		bmi mt_newnotecmd
		clc
		adc mt_chntrans,x	;Add transpose
		sta mt_chnnote,x
               	iny
		lda (mt_pptrlo),y	;Get duration
		sta mt_chncounter,x
		iny
		tya
		sta mt_chnptindex,x
                jsr mt_initvibrato      ;Init vibrato
		ldy mt_chnsndnum,x
                lda mt_snddata+SND_SUSTTIME,y ;Init sustaintiime
                sta mt_chnsusttime,x
		lda mt_snddata+SND_WAVEFORM,y ;Init waveform
		sta mt_chnwaveform,x
		lda mt_snddata+SND_VOLINDEX,y ;Init vol&arptable
		sta mt_chnvolindex,x
		lda mt_chnarpreload,x
		sta mt_chnarpindex,x
		jmp mt_nextchn

mt_newnotecmd:  iny
		sty mt_temp
		asl
		tay
		lda mt_cmdjmptbl,y
                sta mt_sptrlo
		lda mt_cmdjmptbl+1,y
                sta mt_sptrhi
                ldy mt_temp
                lda (mt_pptrlo),y
                jmp (mt_sptrlo)

mt_rest:	sta mt_chncounter,x	;Set duration
		lda #$00            	;Begin release
		sta mt_chnsusttime,x
		iny
		tya
		sta mt_chnptindex,x
                jmp mt_effects

mt_cont:	sta mt_chncounter,x	;Set duration
                iny
		tya
		sta mt_chnptindex,x
		ldy mt_chnsndnum,x
		lda mt_snddata+SND_SUSTTIME,y ;Renew sustaincounter
		sta mt_chnsusttime,x
		jmp mt_effects

mt_snd:         sta mt_chnsndnum,x
		tay
		lda mt_snddata+SND_ARPINDEX,y ;Get sound's arpeggioindex
		sta mt_chnarpreload,x
		ldy mt_temp
		iny
		jmp mt_getnote

mt_arp: 	sta mt_chnarpreload,x
		iny
		jmp mt_getnote

mt_slide:       sta mt_chnslide,x       ;Slide speed
                iny
                lda (mt_pptrlo),y       ;Target note
                clc
                adc mt_chntrans,x       ;Add transpose
                sta mt_chnnote,x
                iny
                lda (mt_pptrlo),y       ;Duration
                jmp mt_cont

mt_effects:     ldy mt_chnarpindex,x	;If there's arpeggio,
		bne mt_getarptbl	;there can't be vibrato/slide
		lda mt_chnslide,x	;Is there slide?
		beq mt_noslide
		jmp mt_slideroutine
mt_noslide:	lda mt_chnvibdelay,x    ;Delay 0 = no vibrato
		beq mt_effectsnovib
		cmp #$02
		bcc mt_dovib
		dec mt_chnvibdelay,x
		jmp mt_effectsnovib
mt_dovib:       lda mt_chnvibadd,x	;Up or down?
		bmi mt_vibdown
		clc
		adc mt_chnfreqlo,x
		sta mt_chnfreqlo,x
		lda mt_chnfreqhi,x
		adc #$00
		sta mt_chnfreqhi,x
		jmp mt_vibdone
mt_vibdown:	clc
		adc mt_chnfreqlo,x
		sta mt_chnfreqlo,x
		lda mt_chnfreqhi,x
		adc #$ff
		sta mt_chnfreqhi,x
mt_vibdone:	lda mt_chnvibcount,x	;Time to reverse direction?
		bne mt_novibreverse
                ldy mt_chnsndnum,x
                lda mt_snddata+SND_VIBSPEED,y
                sta mt_chnvibcount,x
                lda mt_chnvibadd,x
                eor #$ff
                clc
                adc #$01
                sta mt_chnvibadd,x
                jmp mt_effectsnovib
mt_novibreverse:dec mt_chnvibcount,x

mt_effectsnovib:ldy mt_chnarpindex,x	;Arpeggio table effect
		beq mt_noarptbl		;Zero = arp.table stopped
mt_getarptbl:	lda mt_arptbl-1,y
		bpl mt_arptblok
mt_arptbljump:	lda mt_arptbl,y
		tay
		bne mt_getarptbl
mt_arptblend:	sta mt_chnarpindex,x
		beq mt_noarptbl
mt_arptblok:	clc
		adc mt_chnnote,x
		asl
                sty mt_temp
		tay
		lda mt_periodtbl,y	;Init frequency
		sta mt_chnfreqlo,x
		lda mt_periodtbl+1,y
		sta mt_chnfreqhi,x
                ldy mt_temp
		iny
		tya
		sta mt_chnarpindex,x

mt_noarptbl:    ldy mt_chnvolindex,x	;Volume table effect
		beq mt_novoltbl		;Zero = voltable stopped
mt_getvoltbl:	lda mt_voltbl-1,y
                cmp #CMD_JUMPVOL
		bcc mt_voltblok
mt_voltbljump:	lda mt_voltbl,y
                tay
                bne mt_getvoltbl
mt_voltblend:	sta mt_chnvolindex,x
		beq mt_novoltbl
mt_voltblok:	sta mt_chnvolume,x
		iny
		tya
		sta mt_chnvolindex,x

mt_novoltbl:    ldy mt_chnsndnum,x
		lda mt_chnsusttime,x	;Begin release (fadeout)?
                beq mt_release
		cmp #$ff		;255 = never begin release
		beq mt_norelease
		dec mt_chnsusttime,x
		jmp mt_norelease
mt_release:	lda mt_chnvolume,x
		sec
		sbc mt_snddata+SND_RELSPEED,y
		bcs mt_relok
		lda #$00
mt_relok:	sta mt_chnvolume,x
mt_norelease:

mt_nextchn:	inx
		cpx #$04
		bcs mt_allchnsdone
		jmp mt_chnloop
mt_allchnsdone:
mt_loadchannels:
        ;Pulse Channel 1
		lda mt_chnvolume	;Get internal volume: 0-255
		lsr             	;NES volume is 0-15
                lsr
                lsr
		lsr
		ora mt_chnwaveform	;Add waveform
                ora #$30		;Set hold+fixed envelope
		sta $4000
		lda #$08 		;Disable ramping (?)
		sta $4001
		lda mt_chnfreqlo        ;Get frequency lowbyte
                sta $4002
                lda mt_chnfreqhi     	;Get frequency highbyte
                and #$07
                ora #$08
                cmp mt_chnlasthi	;Same as previously?
                beq mt_lchnsame1
                sta mt_chnlasthi
                sta $4003
mt_lchnsame1:
		lda mt_chnvolume+1	;Get internal volume: 0-255
		lsr             	;NES volume is 0-15
                lsr
                lsr
		lsr
		ora mt_chnwaveform+1	;Add waveform
                ora #$30		;Set hold+fixed envelope
		sta $4004
		lda #$08 		;Disable ramping (?)
		sta $4005
		lda mt_chnfreqlo+1      ;Get frequency lowbyte
                sta $4006
                lda mt_chnfreqhi+1     	;Get frequency highbyte
                and #$07
                ora #$08
                cmp mt_chnlasthi+1	;Same as previously?
                beq mt_lchnsame2
                sta mt_chnlasthi+1
                sta $4007
mt_lchnsame2:
        ;Triangle channel
		lda #$ff   		;Set hold+timer
                sta $4008
		lda mt_chnvolume+2	;Volume nonzero?
		bne mt_ltrinormal	;If so, write frequency normally
		sta $400a		;If volume 0, set frequency 0
                cmp mt_chnlasthi+2
                beq mt_lchnsame3
                sta mt_chnlasthi+2
                sta $400b
                jmp mt_lchnsame3
mt_ltrinormal:	lda mt_chnfreqlo+2      ;Get frequency lowbyte
                sta $400a
                lda mt_chnfreqhi+2     	;Get frequency highbyte
                and #$07
                ora #$08
                cmp mt_chnlasthi+2	;Same as previously?
                beq mt_lchnsame3
                sta mt_chnlasthi+2
                sta $400b
mt_lchnsame3:
	;Noise channel
		lda mt_chnvolume+3	;Get internal volume: 0-255
		lsr             	;NES volume is 0-15
                lsr
                lsr
		lsr
                ora #$30		;Set hold+fixed envelope
		sta $400c
		lda #$08 		;Disable ramping (?)
		sta $400d
              	lda mt_chnfreqlo+3
		lsr
		lsr
		lsr
		lsr
		ora mt_chnwaveform+3	;Noise character: normal or metallic
		sta $400e
		lda #$08
		sta $400f
		lda #$0f 		;All channels on
		sta $4015
		rts

	;Slide routine

mt_slideroutine:lda mt_chnnote,x	;This is the target note
		asl
		tay
		lda mt_periodtbl,y	;This is the target period
		sta mt_sptrlo
		lda mt_periodtbl+1,y
		sta mt_sptrhi
                jsr mt_comparefreq
                bcs mt_slidedown
mt_slideup:     lda mt_chnfreqlo,x
                clc
                adc mt_chnslide,x
                sta mt_chnfreqlo,x
                lda mt_chnfreqhi,x
                adc #$00
                sta mt_chnfreqhi,x
                jsr mt_comparefreq
                bcs mt_slideready
                jmp mt_noarptbl
mt_slidedown:   lda mt_chnfreqlo,x
                sec
                sbc mt_chnslide,x
                sta mt_chnfreqlo,x
                lda mt_chnfreqhi,x
                sbc #$00
                sta mt_chnfreqhi,x
                jsr mt_comparefreq
                bcc mt_slideready
                jmp mt_noarptbl
mt_slideready:  lda mt_sptrlo
                sta mt_chnfreqlo,x
                lda mt_sptrhi
                sta mt_chnfreqhi,x
                jsr mt_initvibrato              ;Init possible vibrato when
                jmp mt_noarptbl                 ;the slide has finished

        ;16-bit frequency compare subroutine

mt_comparefreq: lda mt_chnfreqhi,x
                cmp mt_sptrhi
                beq mt_comparelow
                rts
mt_comparelow:  lda mt_chnfreqlo,x
                cmp mt_sptrlo
                rts

        ;Subroutine to init vibrato

mt_initvibrato: lda #$00                        ;Slide off!
                sta mt_chnslide,x
                ldy mt_chnsndnum,x
		lda mt_snddata+SND_VIBDELAY,y
		sta mt_chnvibdelay,x
		beq mt_novibinit		;No vibrato?
                lda mt_snddata+SND_VIBSPEED,y
		lsr
		sta mt_chnvibcount,x
		lda mt_snddata+SND_VIBDEPTH,y
		sta mt_temp
                lda mt_chnnote,x
                asl
                tay
                lda mt_periodtbl,y      ;Calculate vibratoadd
                sec			;from the distance between
                sbc mt_periodtbl+2,y	;two notes' period
                ldy mt_temp
		beq mt_calcvibdone
mt_calcvibloop:	lsr
		dey
		bne mt_calcvibloop
mt_calcvibdone:	sta mt_chnvibadd,x
mt_novibinit:	rts

	;Subroutine to get a pointer to the current pattern
	;X = channel num.

mt_getpattern:	lda mt_chnsptrlo,x
		sta mt_sptrlo
       		lda mt_chnsptrhi,x
		sta mt_sptrhi
		ldy #$00
		lda (mt_sptrlo),y	;Get pattern number
                asl
		tay
		lda (mt_ptbllo),y	;Get address of pattern
		sta mt_pptrlo
		iny
		lda (mt_ptbllo),y
		sta mt_pptrhi
		ldy mt_chnptindex,x
                rts

	;Subroutine for moving into the next pattern

mt_checkpattend:lda (mt_pptrlo),y
		cmp #CMD_ENDPATT
		beq mt_endpatt
mt_nopattend:	rts
mt_endpatt:     lda #$00           	;Reset pattern index for next
		sta mt_chnptindex,x	;pattern
mt_getnextpatt: lda mt_chnsptrlo,x	;Advance to next pattern in the song
                clc
                adc #$01
                sta mt_chnsptrlo,x
                sta mt_sptrlo
                lda mt_chnsptrhi,x
                adc #$00
                sta mt_chnsptrhi,x
                sta mt_sptrhi
mt_getpatt:	ldy #$00
		lda (mt_sptrlo),y	;Check for a valid pattern
		bpl mt_endpattok
		cmp #CMD_ENDSONG  	;Repeat or end song?
		beq mt_endsong
		bcs mt_repeatsong
		and #$7f         	;Otherwise, set transpose
                sbc #$3f                ;Subtract one less (carry set)
		sta mt_chntrans,x
		jmp mt_getnextpatt
mt_repeatsong:	iny
		lda (mt_sptrlo),y	;Get song pointer jump address
		sta mt_chnsptrlo,x
		iny
		lda (mt_sptrlo),y
		sta mt_chnsptrhi,x
                sta mt_sptrhi
                lda mt_chnsptrlo,x
                sta mt_sptrlo
		jmp mt_getpatt
mt_endsong:	lda #$00
		sta mt_playing
mt_endpattok:	rts

	;Music routine tables

mt_cmdjmptbl:	dc.w mt_rest
		dc.w mt_cont
		dc.w mt_snd
		dc.w mt_arp
                dc.w mt_slide

mt_periodtbl:   dc.w 1712,1616,1524,1440,1356,1280,1208,1140,1076,1016,960,906
		dc.w 856,808,762,720,678,640,604,570,538,508,480,453
		dc.w 428,404,381,360,339,320,302,285,269,254,240,226
		dc.w 214,202,190,180,170,160,151,143,135,127,120,113
		dc.w 107,101,95,90,85,80,76,71,67,63,60,57
		dc.w 53,50,48,45,42,40,38,36,34,32,30,28
		dc.w 27

        ;Music data!
        ;Starts with sound data

SND_LEAD1	= 0
mt_snddata:	dc.b WAVE_50 ;Waveform
		dc.b 0 ;Vibdelay
		dc.b 0 ;Vibspeed
		dc.b 0 ;Vibdepth
		dc.b 4 ;Sustain time
		dc.b 2 ;Release speed
		dc.b 1 ;Voltable index
		dc.b 5 ;Arptable index

SND_BASS	= 8
		dc.b WAVE_75 ;Waveform
		dc.b 6 ;Vibdelay
		dc.b 1 ;Vibspeed
		dc.b 1 ;Vibdepth
		dc.b 50 ;Sustain time
		dc.b 16 ;Release speed
		dc.b 1 ;Voltable index
		dc.b 1 ;Arptable index

SND_TRIDRUM     = 16
		dc.b 0 ;Waveform
		dc.b 0 ;Vibdelay
		dc.b 0 ;Vibspeed
		dc.b 0 ;Vibdepth
		dc.b 4 ;Sustain time
		dc.b 255 ;Release speed
		dc.b 6 ;Voltable index
		dc.b 1 ;Arptable index
SND_NOISEDRUM   = 24
		dc.b 0 ;Waveform
		dc.b 0 ;Vibdelay
		dc.b 0 ;Vibspeed
		dc.b 0 ;Vibdepth
		dc.b 4 ;Sustain time
		dc.b 20 ;Release speed
		dc.b 6 ;Voltable index
		dc.b 10 ;Arptable index
SND_NOISEHIHAT  = 32
		dc.b 0 ;Waveform
		dc.b 0 ;Vibdelay
		dc.b 0 ;Vibspeed
		dc.b 0 ;Vibdepth
		dc.b 2 ;Sustain time
		dc.b 48 ;Release speed
		dc.b 3 ;Voltable index
		dc.b 1 ;Arptable index
SND_LEAD2	= 40
		dc.b WAVE_87 ;Waveform
		dc.b 10 ;Vibdelay
		dc.b 5 ;Vibspeed
		dc.b 3 ;Vibdepth
		dc.b 255 ;Sustain time
		dc.b 4 ;Release speed
		dc.b 1 ;Voltable index
		dc.b 1 ;Arptable index

mt_voltbl:	dc.b 0 	         ;1
		dc.b 254         ;2
                dc.b 128         ;3
                dc.b CMD_JUMPVOL ;4
                dc.b 0           ;5
                dc.b 254         ;6
                dc.b CMD_JUMPVOL ;7
                dc.b 0           ;8

mt_arptbl:	dc.b 0		 ;1
		dc.b CMD_JUMPARP ;2
		dc.b 0		 ;3
                dc.b 12          ;4
                dc.b 0           ;5
                dc.b 0           ;6
                dc.b 0           ;7
                dc.b CMD_JUMPARP ;8
                dc.b 4           ;9
                dc.b 1           ;10
                dc.b 0           ;11
                dc.b CMD_JUMPARP ;12
                dc.b 0           ;13

        ;Then song tables & patterns

mt_songtbl:	dc.w song0chn0          ;Song number 0
		dc.w song0chn1
		dc.w song0chn2
		dc.w song0chn3
		dc.w song0patttbl

song0chn0:      dc.b 0,0,0,0
                dc.b 0,0,CMD_TRANS-2,0,0
                dc.b CMD_TRANS+5,0,CMD_TRANS+3,0
                dc.b CMD_TRANS+8,0,CMD_TRANS+10,0
                dc.b CMD_TRANS,0,0,CMD_TRANS+3,0,0
                dc.b CMD_TRANS+5,0,0,CMD_TRANS+8,0,CMD_TRANS+10,0
                dc.b CMD_TRANS,0,0,CMD_TRANS-2,0,0
                dc.b CMD_TRANS+5,0,CMD_TRANS+3,0
                dc.b CMD_TRANS+8,0,CMD_TRANS+10,0
                dc.b CMD_TRANS
		dc.b CMD_JUMPSONG
		dc.w song0chn0

song0chn1:	dc.b 2,2,2,2
                dc.b 1
                dc.b 5,6,7
		dc.b CMD_JUMPSONG
		dc.w song0chn1

song0chn2:	dc.b 4
		dc.b CMD_JUMPSONG
		dc.w song0chn2

song0chn3:	dc.b 3
		dc.b CMD_JUMPSONG
		dc.w song0chn3

song0patttbl:	dc.w song0patt0
		dc.w song0patt1
		dc.w song0patt2
		dc.w song0patt3
		dc.w song0patt4
		dc.w song0patt5
		dc.w song0patt6
		dc.w song0patt7

song0patt0:     dc.b CMD_SND,SND_BASS
                dc.b G0,16
                dc.b G0,16
                dc.b CMD_REST,16
                dc.b G0,8
                dc.b G0,8
                dc.b G0,8
                dc.b G0,8
                dc.b G0,16
                dc.b CMD_REST,16
                dc.b G0,8
                dc.b G0,8
                dc.b CMD_ENDPATT

song0patt1:     dc.b CMD_SND,SND_LEAD1
                dc.b D3,48
                dc.b AS3, 48
                dc.b C4, 32
                dc.b D3,48
                dc.b AS3, 48
                dc.b A3, 32
                dc.b C3,48
                dc.b AS3, 48
                dc.b C4, 32
                dc.b AS3, 48
                dc.b A3,48
                dc.b G3,16
                dc.b F3,16
                dc.b DS3,96
                dc.b F3,32
                dc.b DS3,48
                dc.b D3,48
                dc.b DS3,32
                dc.b F3,48
                dc.b G3,80
                dc.b AS3,48
                dc.b A3,80
                dc.b CMD_ENDPATT

song0patt2:     dc.b CMD_REST,128
		dc.b CMD_ENDPATT

song0patt3:     dc.b CMD_SND,SND_NOISEDRUM
                dc.b D0,16
                dc.b CMD_SND,SND_NOISEHIHAT
                dc.b C1,8
                dc.b C1,8
                dc.b CMD_SND,SND_NOISEDRUM
                dc.b G0,16
                dc.b D0,16
                dc.b CMD_SND,SND_NOISEHIHAT
                dc.b C1,8
                dc.b C1,8
                dc.b CMD_SND,SND_NOISEDRUM
                dc.b D0,16
                dc.b G0,16
                dc.b CMD_SND,SND_NOISEHIHAT
                dc.b C1,8
                dc.b C1,8
                dc.b CMD_ENDPATT

song0patt4:     dc.b CMD_SND,SND_TRIDRUM
                dc.b C2,32
                dc.b G2,16
                dc.b C2,32
                dc.b C2,16
                dc.b G2,32
                dc.b CMD_ENDPATT

song0patt5:     dc.b CMD_SND,SND_LEAD2
                dc.b G1,128
                dc.b D2,64
                dc.b G2,64-12
                dc.b CMD_SLIDE,2,F2,128+12
                dc.b CMD_CONT,128
                dc.b C2,128
                dc.b G2,64
                dc.b C3,64-16
                dc.b CMD_SLIDE,1,AS2,128+16
                dc.b A2,16
                dc.b AS2,16
                dc.b A2,16
                dc.b F2,32
                dc.b D2,16
                dc.b G2,16
                dc.b G2,16
                dc.b CMD_ENDPATT

song0patt6:     dc.b CMD_REST,32
                dc.b D2,16
                dc.b F2,16
                dc.b AS2,8
                dc.b CMD_SLIDE,1,G2,32-8
                dc.b G2,16
                dc.b F2,16
                dc.b G2,16
                dc.b D2,112
                dc.b CMD_REST,32
                dc.b C2,16
                dc.b F2,16
                dc.b AS2,8
                dc.b CMD_SLIDE,1,G2,32-8
                dc.b G2,16
                dc.b F2,16
                dc.b G2,2,CMD_SLIDE,4,A2,128-2
                dc.b CMD_ENDPATT
song0patt7:     dc.b CMD_REST,32
                dc.b C2,16
                dc.b DS2,16
                dc.b G2,16-4,CMD_SLIDE,3,F2,16+4
                dc.b DS2,16
                dc.b F2,16
                dc.b DS2,48-8,CMD_SLIDE,1,D2,8
                dc.b D2,48
                dc.b DS2,32
                dc.b F2,48
                dc.b G2,80
                dc.b AS2,48-8,CMD_SLIDE,1,A2,8
                dc.b A2,80
                dc.b CMD_ENDPATT

        ;Music data ends

palette:        incbin scrtest.pal
chardata:       incbin scrtest.chr

                .org $fffa

                dc.w nmi
                dc.w start
                dc.w irq
